#!/bin/sh 
###
#	Licensed Materials - Property of IBM Corp.
#	@PLUGIN_NAME@
#	(c) Copyright IBM Corporation 2003, 2013. All Rights Reserved.
#	
#	U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by
#	GSA ADP Schedule Contract with IBM Corp.
#	
#	Filename: setupCmdLine.sh
#	
#	
###

setRAFWHome()
{
    CUR_DIR=`pwd`
    RAFW_DIR=`dirname "${0}"`
    RAFW_DIR=${RAFW_DIR}/../
    cd "${RAFW_DIR}"
    MCWAS_HOME=`pwd`
    cd "${CUR_DIR}"
}
setRAFWHome
bitWidthOverrideDir=""
# determine the operating system to JAVA_HOME correctly
 UNAME=`/bin/uname | sed -e 's/\(CYGWIN\).*/\1/'`
 case $UNAME in
  AIX)
  OS=aix
        OS_TYPE_TEST=`getconf -a | grep KERN | grep 64`
        if [ "${OS_TYPE_TEST}" != "" ]; then
                OS_DIR=aix/PPC64
                bitWidthOverrideDir=aix/PPC32 
        else
                OS_DIR=aix/PPC32
        fi
  EXTSHM=ON
      export EXTSHM 
  ;;
  Linux)
  OS=linux
        OS_TYPE_TEST=`uname -a | grep ia64`
        if [ "${OS_TYPE_TEST}" != "" ]; then
                OS_TYPE_TEST=`${SSH_CALL} uname -a | grep x86_64`
		else
			OS_TYPE_TEST=`uname -a | grep x86_64`
        fi

        OS_TYPE_TEST_390=`uname -a | grep s390`
        if [ "${OS_TYPE_TEST_390}" != "" ]; then        	
    		OS_TYPE_TEST=$OS_TYPE_TEST_390
			if [ "${OS_TYPE_TEST_390}" != "" ]; then
				OS_DIR=linux/s390_64
				bitWidthOverrideDir=linux/s390
				DONE=true
			else
				OS_DIR=linux/s390
				DONE=true
			fi
  		fi	
		
		if [ "${DONE}" == "" ]; then
    	    if [ "${OS_TYPE_TEST}" != "" ]; then
        	        OS_DIR=linux/X64
            	    bitWidthOverrideDir=linux/X32
        	else
            	    OS_DIR=linux/X32
        	fi
        fi
  ;;
  SunOS)
  OS=solaris
  		#TODO need a check for Solaris X64!
  		#32 bit override not supported on AMD/Intel
        OS_TYPE_TEST=`isainfo -v | grep 64`
        if [ "${OS_TYPE_TEST}" != "" ]; then
               OS_TYPE_TEST=`isainfo -v | grep amd64`
               if [ "${OS_TYPE_TEST}" != "" ]; then
                       OS_DIR=solaris/X64
               else
                       OS_DIR=solaris/Sparc64
                       bitWidthOverrideDir=solaris/Sparc               
               fi
        else
                OS_DIR=solaris/Sparc
        fi
  ;;
  HP-UX)
        OS=hpux
        OS_TYPE_TEST=`uname -a | grep ia64`
        if [ "${OS_TYPE_TEST}" != "" ]; then
                OS_DIR=hpux/IA64
                #32 bit override not supported on HP-UX
        else
                OS_DIR=hpux/PaRISC
        fi
        ;;
  OS400)
        OS=os400
        OS_TYPE=64bit
        PLATFORM=iSeries
        ;;
esac

CLASSPATH=${MCWAS_HOME}/product/lib/jython/jython.jar
for jar in ${MCWAS_HOME}/product/lib/java/*.jar; do
	CLASSPATH=${CLASSPATH}:${jar};
done
for jar in ${MCWAS_HOME}/product/lib/java/wsadmin_lib/*.jar; do
	CLASSPATH=${CLASSPATH}:${jar};
done
for jar in ${MCWAS_HOME}/product/lib/ant/*.jar; do
	CLASSPATH=${CLASSPATH}:${jar};
done
for module in ${MCWAS_HOME}/modules/; do
	for jar in ${module}/lib/*.jar; do
		CLASSPATH=${CLASSPATH}:${jar};
	done
done
for jar in ${MCWAS_HOME}/framework/lib/java/*.jar; do
	CLASSPATH=${CLASSPATH}:${jar};
done
for jar in ${MCWAS_HOME}/java/*.jar; do
	CLASSPATH=${CLASSPATH}:${jar};
done


PATH=$JAVA_HOME/bin:$PATH
PYTHONPATH=${PYTHONPATH}:${MCWAS_HOME}/product/lib/jython:${MCWAS_HOME}/product/lib/jython/wsadmin_lib
export MCWAS_HOME CLASSPATH PATH OS PYTHONPATH JAVA_HOME

