@echo off
REM
REM BEGIN COPYRIGHT
REM *************************************************************************
REM Licensed Materials - Property of IBM 
REM 5724-L01, 5655-N53, 5724-I82, 5655-R15
REM (C) Copyright IBM Corporation 2006. All rights reserved. 
REM US Government Users Restricted Rights - Use, duplication, or disclosure
REM restricted by GSA ADP Schedule Contract with IBM Corp.
REM *************************************************************************
REM END COPYRIGHT
REM -------------------------------------------------------------------------------------------
REM -- This batch file creates CommonDB database 
REM --
REM -- 
REM -- This file for use on Windows systems
REM -- 
REM -- Usage: 
REM --      db2cmd createDBTables.bat  <db_user>  <dbName> [createDB]
REM -- Example:
REM --      db2cmd createDBTables.bat db2admin WPRCSDB createDB     --create a new db
REM --      db2cmd createDBTables.bat db2admin WPRCSDB              --use an existing db
REM -------------------------------------------------------------------------------------------

setlocal

set DB_USER=%1
set DB_NAME=%2
set DB_CREATE=%3

if "%DB_CREATE%"=="createDB" set createDB=TRUE
if not "%DB_CREATE%"=="createDB" set createDB=FALSE


REM If no password is specified then let DB2 prompt
set USING=""


IF "%createDB%"=="TRUE" goto CREATE_DB
IF "%createDB%"=="FALSE" goto EXIST_DB

REM return code
set RC=0 

:CREATE_DB

@db2 create database %DB_NAME% automatic storage yes using codeset UTF-8 territory US
set RC=%ERRORLEVEL%
if not %RC%==0 goto END

:EXIST_DB

goto CREATETABLE

:CREATETABLE

@db2 connect to %DB_NAME% USER %DB_USER% %USING%
set RC=%ERRORLEVEL%
if not %RC%==0 goto END

@db2 set current schema=%DB_USER%

dir /B | findstr "[create][insert]Table" > files.log

for /F "tokens=1* delims=" %%v in ( files.log ) do (
       @db2 -s -t -f ".\%%v"
)


:END
exit %RC%
endlocal
