@echo off
REM BEGIN COPYRIGHT
REM *************************************************************************
REM Licensed Materials - Property of IBM 
REM 5724-L01, 5655-N53, 5724-I82, 5655-R15
REM (C) Copyright IBM Corporation 2006. All rights reserved. 
REM US Government Users Restricted Rights - Use, duplication, or disclosure
REM restricted by GSA ADP Schedule Contract with IBM Corp.
REM *************************************************************************
REM END COPYRIGHT
REM 
REM -- Description:   Configure DB2 Database environment for CommonDB during Migrtaion based 
REM --			      Migrating WBI version
REM --                This file for use on Windows systems
REM --                This batch file updates CommonDB database 
REM --
REM -- Usage: 
REM --                upgradeSchema.bat  <product_version>  <dbName> <dbuser>
REM -- Example:
REM --                upgradeSchema.bat 602 WPRCSDB dbUserId  
REM --                password will be prompted
REM -------------------------------------------------------------------------------------------
setlocal

set PRODUCT_VERSION=%1
set DB_NAME=%2
set DB_USER=%3

if  not "%1" == ""  (
  if not "%2"==""  (
  	if not "%3"==""  (
		goto INPUT_PRODUCT_VERSION
  	) else (
	  echo ======================================================================
  	  echo "One or more parameters are missing..."
	  goto PRINT_USAGE
	)
  ) else (
    echo ======================================================================
  	echo "One or more parameters are missing..."
	goto PRINT_USAGE
  )
) 

:INPUT_PRODUCT_VERSION
if "%PRODUCT_VERSION%"==""  (
  set /p PRODUCT_VERSION="Enter WBI version that you migrtated [602 | 610 |612]:": 
  goto INPUT_PRODUCT_VERSION
)

:INPUT_DBNAME
if "%DB_NAME%"==""  (
  set /p DB_NAME="Enter DB2 Database Name[WPRCSDB]:":  
  goto INPUT_DBNAME
)

:INPUT_USERNAME
if "%DB_USER%"==""  (
  set /p DB_USER="Enter DB2 user[dbUserId]:":
  goto INPUT_USERNAME
)

db2cmd /w /c /i .\upgradeSchemaTables.bat %PRODUCT_VERSION% %DB_NAME% %DB_USER% 

goto END 

:PRINT_USAGE

REM Print usage messages


echo ======================================================================
echo Usage: upgradeSchema.bat ^<product_version^>  ^<dbName^> ^<dbuser^>
echo Parameters:
echo product_version   -  Specify the migration version ie., 602 or 610 or 612 
echo dbname	           -  DB2 Database Name(dbName) ie., WPRCSDB 
echo dbuser            -  User who can execute common scripts ie.,dbUserId
echo Examples:
echo         1. upgradeSchema.bat
echo         2. upgradeSchema.bat 602 WPRCSDB dbUserId 
echo ======================================================================

goto END

:END

endlocal