@echo off
REM
REM BEGIN COPYRIGHT
REM @start_restricted_prolog@                                             
REM Licensed Materials - Property of IBM                                  
REM 5724-I82 5724-L01 5655-N63 5655-R15                                   
REM Copyright IBM Corporation 2006 All Rights Reserved.             
REM US Government Users Restricted Rights- Use, duplication or disclosure 
REM restricted by GSA ADP Schedule Contract with IBM Corp.                
REM @end_restricted_prolog@                                               
REM END COPYRIGHT

REM -------------------------------------------------------------------------------------------
REM -- This batch file creates CommonDB database 
REM --
REM -- 
REM -- This file for use on Windows systems
REM -- 
REM -- Usage: 
REM --      db2cmdconfigCommonDB.bat  <db_user>  <dbName> [createDB]
REM -- Example:
REM --      db2cmdconfigCommonDB.bat db2admin WPRCSDB createDB     --create a new db
REM --      db2cmdconfigCommonDB.bat db2admin WPRCSDB              --use an existing db
REM -------------------------------------------------------------------------------------------

setlocal

set DB_USER=%1
set DB_NAME=%2
set DB_CREATE=%3

if "%DB_CREATE%"=="createDB" set createDB=TRUE
if not "%DB_CREATE%"=="createDB" set createDB=FALSE


REM If no password is specified then let DB2 prompt
set USING=""

set createTable_EsbLoggerMediation_SQL=.\createTable_EsbLoggerMediation.sql



IF "%createDB%"=="TRUE" goto CREATE_DB
IF "%createDB%"=="FALSE" goto EXIST_DB

REM return code
set RC=0 

:CREATE_DB

@db2 create database %DB_NAME% using codeset UTF-8 territory US
set RC=%ERRORLEVEL%
if not %RC%==0 goto END

:EXIST_DB

goto CREATETABLE

:CREATETABLE

@db2 connect to %DB_NAME% USER %DB_USER% %USING%
set RC=%ERRORLEVEL%
if not %RC%==0 goto END

@db2 set current schema=%DB_USER%
@db2 -s -t -f ".\%createTable_EsbLoggerMediation_SQL%"

:END
exit %RC%
endlocal
