"""
	Licensed Materials - Property of IBM Corp. 
IBM Middleware Configuration for WebSphere 
(c) Copyright IBM Corporation 2003, 2013. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: addCompUnit.py
	
	TODO: description
"""

import sys

LOGGER = _Logger("addCompUnit", MessageManager.RB_WEBSPHERE_WAS)

def addCompUnit ( blaName, cuSourceID , cuName , cuDescription , startingWeight , activationPlan, mapTargets ):
	
	global AdminTask
	global AdminConfig
		
	if (checkIfBLAExists(blaName)=="true"):
		cus = AdminTask.listCompUnits(['-blaID', blaName])
		if (cus.find(cuSourceID) > 0):
			print "CompUnit " + cuSourceID + " already exists!"
		else:

			if cuDescription is None:
				cuDescription = ""
		
			if startingWeight is None or len(startingWeight) == 0:
				startingWeight = "0"
				
			params = ['-blaID', blaName, '-cuSourceID', cuSourceID,
					'-CUOptions', [['.*', '.*', cuName, cuDescription, startingWeight]]]
			if activationPlan is not None and len(activationPlan) > 0:
				params.append('-ActivationPlanOptions')
				params.append([['.*',activationPlan]])
			#endIf

			if mapTargets is not None and len(mapTargets) > 0:
				params.append('-MapTargets')
				params.append([['.*',mapTargets]]) 
			#endIf
			LOGGER.info("Calling AdminTask.addCompUnit(" + str(params) + ")")
			
			AdminTask.addCompUnit(params)
			AdminHelper.saveAndSyncCell()		
		#endElse	  
	else:
		print "BLA "+blaName+" doesn't exist!"
	#endElse 
#endDef 

def checkIfBLAExists ( blaName ):
	global AdminTask
	blaExists = "true"
	
	blas = AdminTask.listBLAs(['-blaID', blaName])
	if (len(blas) == 0):
		blaExists = "false"
	#endIf 
	return blaExists
#endDef 


optDict, args = SystemUtils.getopt( sys.argv, 'blaName:;cuSourceID:;cuName:;cuDescription:;startingWeight:;activationPlan:;mapTargets:;mode:')
blaName = optDict['blaName']
cuSourceID = optDict['cuSourceID']
cuName = optDict['cuName']
cuDescription = optDict['cuDescription']
startingWeight = optDict['startingWeight']
activationPlan = optDict['activationPlan']
mapTargets = optDict['mapTargets']
 
addCompUnit( blaName, cuSourceID , cuName , cuDescription , startingWeight ,  activationPlan, mapTargets )
