"""
	Licensed Materials - Property of IBM Corp. 
IBM Middleware Configuration for WebSphere 
(c) Copyright IBM Corporation 2003, 2013. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: editCompUnit.py
	
	TODO: description
"""

import sys

LOGGER = _Logger("editCompUnit", MessageManager.RB_WEBSPHERE_WAS)

def editCompUnit ( blaName, cuName , cuDescription , startingWeight , activationPlan, mapTargets ):
	
	global AdminTask
	global AdminConfig
		
	if (checkIfBLAExists(blaName)=="true"):
		cus = AdminTask.listCompUnits(['-blaID', blaName])
		if (cus.find(cuName) < 0):
			print "CompUnit " + cuName + " doesn't exist!"
		else:
			if cuDescription is None:
				cuDescription = ""
		
			if startingWeight is None or len(startingWeight) == 0:
				startingWeight = "0"
				
			params = ['-blaID', blaName, '-cuID', cuName,
					'-CUOptions', [['.*', '.*', '.*', cuDescription, startingWeight]]]
			
			if activationPlan is not None and len(activationPlan) > 0:
				params.append('-ActivationPlanOptions')
				params.append([['.*',activationPlan]])
			#endIf
			
			if mapTargets is not None and len(mapTargets) > 0:
				params.append('-MapTargets')
				params.append([['.*',mapTargets]]) 
			#endIf
			
			LOGGER.info("Calling AdminTask.editCompUnit(" + str(params) + ")")
			AdminTask.editCompUnit(params)
			AdminHelper.saveAndSyncCell()		
		#endElse          
	else:
		print "BLA "+blaName+" doesn't exist!"
	#endElse 
#endDef 

def checkIfBLAExists ( blaName ):
	global AdminTask
	blaExists = "true"
        
	blas = AdminTask.listBLAs(['-blaID', blaName])
	if (len(blas) == 0):
		blaExists = "false"
	#endIf 
	return blaExists
#endDef 


optDict, args = SystemUtils.getopt( sys.argv, 'blaName:;cuName:;cuDescription:;startingWeight:;activationPlan:;mapTargets:;mode:')
blaName = optDict['blaName']
cuName = optDict['cuName']
cuDescription = optDict['cuDescription']
startingWeight = optDict['startingWeight']
activationPlan = optDict['activationPlan']
mapTargets = optDict['mapTargets']
 
editCompUnit( blaName, cuName , cuDescription , startingWeight ,  activationPlan, mapTargets )


