"""
	Licensed Materials - Property of IBM Corp. 
IBM Middleware Configuration for WebSphere 
(c) Copyright IBM Corporation 2003, 2013. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: updateStartingWeight.py
	
	TODO: description
"""


import sys

updateStartingWeightLogger = _Logger("updateStartingWeight", MessageManager.RB_WEBSPHERE_WAS)

def updateStartingWeight (appName, modName, modStartWeight ):

        # read available installable apps
        global AdminApp
        global AdminConfig
        
        appExists = WasDeploy.checkIfAppExists(appName )
        application = AdminConfig.getid("/Deployment:"+appName+"/" ).strip()
        appObjectRef = AdminConfig.showAttribute(application, 'deployedObject')
        modules = AdminConfig.showAttribute(appObjectRef, 'modules')
        arrayModules = modules[1:len(modules)-1].split(" ")
		  
        if (appExists):
            for module in arrayModules:        
                tmp = AdminConfig.showAttribute(module,'uri')
                if tmp == modName:
                    # print " "+modName+" starting weight is set to "+modStartWeight+"."
                     updateStartingWeightLogger.log("CRWWA5063I",[modName,modStartWeight])
                     AdminConfig.modify(module, [["startingWeight", modStartWeight]])
                     break
				#endif
            #endFor
        else:
           # print " "+appName+" doesn't exist in the current config."
           updateStartingWeightLogger.log("CRWWA5064I")
        #endIF
#endDef 

appName = sys.argv[2]
modName = str(sys.argv[3])
optDict, args = SystemUtils.getopt( sys.argv, 'appProps:' )

# parse the properties into props
props = SystemUtils.getPropertyDict( optDict['appProps'] )
if (props.has_key(modName)):
	modStartWeight = props[modName]
	updateStartingWeight(appName, modName, modStartWeight)
	AdminHelper.saveAndSyncCell()
else:
	#print "Error: Starting weight for module " + modName + " not defined."
	updateStartingWeightLogger.log("CRWWA5065I")
#endFor

