"""
	Licensed Materials - Property of IBM Corp. 
IBM Middleware Configuration for WebSphere 
(c) Copyright IBM Corporation 2003, 2013. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: disableWpApps.py
	
	Description: disables applications in WAS according to the supplied set of application names
"""

import sys
from Logger import _Logger
from com.ibm.rational.rafw.wsadmin.logging import MessageManager

LOGGER = _Logger("disableWpApps", MessageManager.RB_WEBSPHERE_WP)

def disableWpApps( propFile ):
	propFile = open(""+propFile+"", "r")
	for appName in propFile.readlines():
		LOGGER.trace("Attempting to disable "+appName+" ...")
		appUpdated = 0
		if (len(appName) > 0):
			application = AdminConfig.getid("/Deployment:"+appName+"/" ).strip()
			if (len(application) > 0):
				app_attribute  = AdminConfig.showAttribute(application, "deployedObject")
				if (len(app_attribute) > 0):
					app_target_mapping = AdminConfig.showAttribute(app_attribute, "targetMappings")
					if (len(app_target_mapping) > 2):
						app_target_mapping = app_target_mapping[1:len(app_target_mapping)-1].split(" ")
						for targetMapping in app_target_mapping:
							if (len(targetMapping) > 0):
								LOGGER.info("Disabling "+appName+" ...")
								AdminConfig.modify(targetMapping, [["enable", "false"]])
								appUpdated = 1
							#endIf
						#endIf
					#endIf
				#endIf
				if (not appUpdated):
					LOGGER.error("Unable to disable "+appName+": The application does not have a configured server mapping.")
				#endIf
			else:
				LOGGER.error("Unable to disable "+appName+": The application cannot be found in the system configuration.")
			#endIf
		#endIf
	#endFor
	propFile.close()
#endDef 

optDict, args = SystemUtils.getopt( sys.argv, 'propFile:;mode:' )

disableWpApps( optDict['propFile'] )

AdminHelper.saveAndSyncCell()

