"""
	Licensed Materials - Property of IBM Corp. 
IBM Middleware Configuration for WebSphere 
(c) Copyright IBM Corporation 2003, 2013. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: wp51UpdatePorts.py
	
	TODO: description
"""

import sys
from org.python import modules
from sys import argv
from java.util import Properties
from java.util import Hashtable
from java.io import FileInputStream

arglen=len(sys.argv)
num_exp_args=1 
usage="[fully qualified path of  property file]"  
if (arglen != num_exp_args):
	raise "Usage: %s" % (usage)

#Read properties file.
propFile=argv[0]
properties=Properties();

try:
	properties.load(FileInputStream(propFile))
	print "Succesfully read property file %s" % (propFile)
except:
	raise "Cannot read property file %s" % (propFile)

#an array of the needed port keys
portKeyArray=["WP_BOOTSTRAP_ADDRESS","WP_HTTP_TRANSPORT","WP_HTTPS_TRANSPORT","WP_JMSSERVER_DIRECT_ADDRESS",
   "WP_JMSSERVER_QUEUED_ADDRESS","WP_SOAP_CONNECTOR_ADDRESS","WP_DRS_CLIENT_ADDRESS",
   "WP_CSIV2_SSL_SERVERAUTH_LISTENER_ADDRESS","WP_HTTP_ADMIN","WP_HTTPS_ADMIN","WP_ORB_LISTENER_ADDRESS",
   "WP_CSIV2_SSL_MUTUALAUTH_LISTENER_ADDRESS","WP_SAS_SSL_SERVERAUTH_LISTENER_ADDRESS"]


#WP_STARTING_POINT


#Load in needed port values into a hash table
myHashtable=Hashtable()


startPoint = int(properties.getProperty("WP_STARTING_POINT"))

if (startPoint):
	portKey=""
	for portKey in portKeyArray:
		port = startPoint
		myHashtable.put(portKey,port)
		print "%s=%s" % (portKey,port)
		startPoint = startPoint + 1
else:
	try:
		portKey=""
		for portKey in portKeyArray:
			port=properties.getProperty(portKey)
			myHashtable.put(portKey,port)
			print "%s=%s" % (portKey,port)
	except:
		raise "Cannot load valid port value for property key %s" % (portKey)

#Load in hostname
hostNameKey="HOST_NAME"
hostName=str(properties.getProperty(hostNameKey))
if (hostName=="None"):
	raise "Cannot find valid host name for key %s" % (hostNameKey)
else:
	print "%s=%s" % (hostNameKey,hostName)

#Load in nodeName
nodeNameKey="NODE_NAME"
nodeName=str(properties.getProperty(nodeNameKey))
if (nodeName=="None"):
	raise "Cannot find valid node name for key %s" % (nodeNameKey)
else:
	print "%s=%s" % (nodeNameKey,nodeName)

#get the id for WebSphere Portal
s=AdminConfig.getid('/Server:WebSphere_Portal/') 
 
#Identify the Web container belonging to the server and assign it to the wc variable.
wc = AdminConfig.list('WebContainer', s)
 
#List all the transports belonging to the Web container and assign it to the transports variable
transportsAttr = AdminConfig.showAttribute(wc, 'transports')
 
# eliminate the beginning "[" and the end "]"
transports = transportsAttr[1:len(transportsAttr)-1]
 
#loop over transports and delete each one
for transport in transports.split():
	print "Removing %s" % (transport)
 	AdminConfig.remove(transport)
 
#--------------------------------------------------------------
# Change the list of transports associated with the WebContainer
# for this server.  Create one secure and one non-secure transport 
#--------------------------------------------------------------
print "modifying HTTP port addresses"
WP_HTTP_TRANSPORT=int(myHashtable.get("WP_HTTP_TRANSPORT"))
WP_HTTPS_TRANSPORT=int(myHashtable.get("WP_HTTPS_TRANSPORT"))
httpNonSecureAddress = [["sslEnabled", "false"], ["address", [["host", ""], ["port", WP_HTTP_TRANSPORT]]]]
nodeDefaultSSLSettings=nodeName + "/DefaultSSLSettings"
httpSecureAddress = [["sslEnabled", "true"], ["address", [["host", hostName], ["port", WP_HTTPS_TRANSPORT]]], ["sslConfig", nodeDefaultSSLSettings]]
transports = [["transports:HTTPTransport", [httpNonSecureAddress, httpSecureAddress]]]
webContainer = AdminConfig.list("WebContainer", s)
AdminConfig.modify(webContainer, transports)

#update serverindex endpoints

for svrEntry in AdminConfig.getid("/Node:"+nodeName+"/ServerIndex:/ServerEntry:/" ).split():
   if (AdminConfig.showAttribute(svrEntry, "serverName") == "WebSphere_Portal"):
      list = AdminConfig.show(svrEntry,"specialEndpoints").split(' ', 1)[1]
      epList = list[ 2:len(list)-3 ]
      for nep in epList.split():
         endPoint = AdminConfig.showAttribute( nep, "endPoint" )
         endPointNm = AdminConfig.showAttribute( nep, "endPointName" )
         print "modifying %s" % (endPointNm)
         if ((myHashtable.get("WP_" + endPointNm) == None) or (myHashtable.get("WP_" + endPointNm) == "")):
            print "Port not found for %s, skipping." % (endPointNm)
            continue
         else:
            epPort = int(myHashtable.get("WP_" + endPointNm))
			#endIf
         AdminConfig.modify(endPoint, [['host', hostName],['port', epPort]])
		#endFor
	#endIf
#endFor


#get virtual hosts
myVirtualHost=AdminConfig.list('VirtualHost')
 
#turn virtual host into an array
myVirtualHost=myVirtualHost.split()
 
myDefaultHost=""
#iterate over virtualhost searching for default host
for i in range(len(myVirtualHost)):
	if modules.re.search(r"^default_host.*",myVirtualHost[i]):
 		myDefaultHost=myVirtualHost[i]
 		#create host alias for initial http
		http=str(WP_HTTP_TRANSPORT)
 		myString='[[hostname *][port ' + http + ']]'	
 		print 'Adding HostAlias *:%i to %s' % (http,myDefaultHost)
 		AdminConfig.create('HostAlias',myDefaultHost,myString)
AdminConfig.save()
