"""
	Licensed Materials - Property of IBM Corp. 
IBM Middleware Configuration for WebSphere 
(c) Copyright IBM Corporation 2003, 2013. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: WpConfig.py
	
	Encapsulates useful utilities used for WebSphere Portal specific configuration
"""

import AdminConfig

"""
CLASS :: _WpConfig
Encapsulates useful utilities used for                 
WebSphere Portal specific configuration                
"""
class _WpConfig:
	
	"""
	updateCustomUserRegistry 
	       Description:                                     
	               Update the Custom User Registry          
	               properties to add userRegistryRealm      
	                                                        
	   Inputs:                                              
	       ldapHost = ldap hostname                         
	"""
	def updateCustomUserRegistry (self, ldapHost, ldapPort):
		customerReg = AdminConfig.list("CustomUserRegistry")
		value=ldapHost+":"+ldapPort
		print "Adding property userRegistryRealm with value" + value + " to CustomUserRegistry"
		AdminConfig.modify(customerReg, [['properties',[[['name', 'userRegistryRealm'], ['value', value]]]]])
		print "Saving Config..."
		AdminConfig.save()
	#endDef	
	
#endClass

## define global singletons
WpConfig = _WpConfig()	

