CREATE TABLE XMetaLockInfo (  
	repository_id VARCHAR (64) NOT NULL, 
	locked_at NUMERIC(31,7) NOT NULL ,
	locked_by_user VARCHAR (256) NOT NULL,
	locked_by_session VARCHAR (256) NOT NULL,
        needs_upgrade SMALLINT,
	CONSTRAINT XMetaLockInfo_PK  PRIMARY KEY ( repository_id) ) IN @DBNAME@DATA ;

CREATE INDEX SessionLock ON XMetaLockInfo ( locked_by_session );
 
CREATE TABLE EPackage(
	uri VARCHAR (255) NOT NULL ,
	xml clob (1 G) NOT NULL ) IN @DBNAME@DATA ;

CREATE TABLE ModelArtifact (
	uri 		VARCHAR (255) NOT NULL,
	name		VARCHAR	(255)  NOT NULL,
	file_name	VARCHAR	(255) ,
	file_type	VARCHAR	(64)  ,
	content_type	VARCHAR	(64)  ,
	description	VARCHAR	(255)  ,
	content		BLOB	(255M)  NOT NULL,
	active		SMALLINT	NOT NULL,
	CONSTRAINT ModelArtifact_PK  PRIMARY KEY (uri, name) ) IN @DBNAME@DATA ;


CREATE TABLE ModelDeploymentInfo (
	prime_key_value BIGINT			NOT NULL,
	repository_id 	VARCHAR		(64) 	NOT NULL ,
	uri 		VARCHAR 	(255)	NOT NULL ,
	model_name	VARCHAR		(255)	NOT NULL ,
	username	VARCHAR		(64)	NOT NULL ,
	timestamp	BIGINT			NOT NULL ,
	status		INTEGER 		NOT NULL ,
	converted_deployment	SMALLINT	NOT NULL,
	CONSTRAINT MdlDeptMetadata_PK  PRIMARY KEY (prime_key_value) ) IN @DBNAME@DATA ;


CREATE TABLE ModelDeploymentLockInfo (
	prime_value	SMALLINT	NOT NULL ,
	lock_value	SMALLINT	NOT NULL ,
 	username	VARCHAR(64)	NOT NULL ,
	timestamp	BIGINT		NOT NULL ,

	CONSTRAINT MdlDeptLckInfo_PK  PRIMARY KEY (prime_value) ) IN @DBNAME@DATA ;

CREATE TABLE SecuredModelList (
	nsUri VARCHAR (255) NOT NULL,
	secured INTEGER,
	PRIMARY KEY (nsUri) ) IN @DBNAME@DATA ;

