-- The WSRR installer will replace the DBNAME, DBUSER and DB2TSDIR variables in this file

-- Licensed Materials - Property of IBM
-- 5724-N72 5655-R41
-- (c) Copyright IBM Corp. 2006, 2007 All Rights Reserved
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.

-- AUTOCONFIGURE:
-- ==============
-- DB2 will automatically configure 25% of physical memory for the database
-- and the USERSPACE1 tablespace will automatically be configured to use
-- automatic storage, with an initial size of 500M

-- if using a different database for activity logging from the main ts database,
-- remove the -- actdb -- marker from the start of the following lines
CREATE DATABASE @ACTDBNAME@ ON @DB2TSDIR@ ALIAS @ACTDBNAME@ 
       USING CODESET UTF-8 TERRITORY US 
       COLLATE USING IDENTITY
       USER TABLESPACE
         MANAGED BY AUTOMATIC STORAGE
         AUTORESIZE YES
         INITIALSIZE 500 M
         INCREASESIZE 10 PERCENT
         MAXSIZE NONE;

CONNECT TO @ACTDBNAME@;

CREATE BUFFERPOOL @ACTDBNAME@ACT IMMEDIATE 
    SIZE 1000 AUTOMATIC 
    NUMBLOCKPAGES 256
    BLOCKSIZE 32
    PAGESIZE 32K; 
CREATE BUFFERPOOL @ACTDBNAME@TMP IMMEDIATE 
    SIZE 1000 AUTOMATIC 
    NUMBLOCKPAGES 256
    BLOCKSIZE 32
    PAGESIZE 32K;

-- Create a DMS tablespace with 32k pagesize to hold wide tables
-- whose storage is automatically managed by DB2

CREATE REGULAR TABLESPACE @ACTDBNAME@ACT
       IN DATABASE PARTITION GROUP IBMDEFAULTGROUP 
       PAGESIZE 32768 
       MANAGED BY AUTOMATIC STORAGE
       AUTORESIZE YES
       INITIALSIZE 100 M
       INCREASESIZE 10 PERCENT
       MAXSIZE NONE
       EXTENTSIZE 16
       BUFFERPOOL @ACTDBNAME@ACT
       FILE SYSTEM CACHING  
       DROPPED TABLE RECOVERY ON;

-- Create a temorary SMS tablespace for the Activity Logging regular tablespace
-- whose storage is automatically managed by DB2
CREATE TEMPORARY TABLESPACE @ACTDBNAME@TEMP 
       IN DATABASE PARTITION GROUP IBMTEMPGROUP 
       PAGESIZE 32768 
       MANAGED BY AUTOMATIC STORAGE
       EXTENTSIZE 16
       BUFFERPOOL @ACTDBNAME@TMP
       FILE SYSTEM CACHING ;

COMMENT ON TABLESPACE @ACTDBNAME@ACT IS '32 page WSRR Activity Logging Data space';
COMMENT ON TABLESPACE @ACTDBNAME@TEMP IS '32 page swap';

COMMIT WORK;
CONNECT RESET;
TERMINATE; 
