-- Licensed Materials - Property of IBM
-- 5724-N72 5655-R41
-- (c) Copyright IBM Corp. 2006, 2007 All Rights Reserved
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.

CREATE TABLE "WSRRTASK" ("TASKID" BIGINT NOT NULL ,
              "VERSION" VARCHAR(5) NOT NULL ,
              "ROW_VERSION" INTEGER NOT NULL ,
              "TASKTYPE" INTEGER NOT NULL ,
              "TASKSUSPENDED" SMALLINT NOT NULL ,
              "CANCELLED" SMALLINT NOT NULL ,
              "NEXTFIRETIME" BIGINT NOT NULL ,
              "STARTBYINTERVAL" VARCHAR(254) ,
              "STARTBYTIME" BIGINT ,
              "VALIDFROMTIME" BIGINT ,
              "VALIDTOTIME" BIGINT ,
              "REPEATINTERVAL" VARCHAR(254) ,
              "MAXREPEATS" INTEGER NOT NULL ,
              "REPEATSLEFT" INTEGER NOT NULL ,
              "TASKINFO" BLOB(102400) LOGGED NOT COMPACT ,
              "NAME" VARCHAR(254) NOT NULL ,
              "AUTOPURGE" INTEGER NOT NULL ,
              "FAILUREACTION" INTEGER ,
              "MAXATTEMPTS" INTEGER ,
              "QOS" INTEGER ,
              "PARTITIONID" INTEGER ,
              "OWNERTOKEN" VARCHAR(200) NOT NULL ,
              "CREATETIME" BIGINT NOT NULL )  IN "@DBNAME@SCHED";

ALTER TABLE "WSRRTASK" ADD PRIMARY KEY ("TASKID");

CREATE INDEX "WSRRTASK_IDX1" ON "WSRRTASK" ("TASKID",
              "OWNERTOKEN") ;

CREATE INDEX "WSRRTASK_IDX2" ON "WSRRTASK" ("NEXTFIRETIME" ASC,
               "REPEATSLEFT",
               "PARTITIONID") CLUSTER;

CREATE TABLE "WSRRTREG" ("REGKEY" VARCHAR(254) NOT NULL ,
              "REGVALUE" VARCHAR(254) ) IN "@DBNAME@SCHED";

ALTER TABLE "WSRRTREG" ADD PRIMARY KEY ("REGKEY");

CREATE TABLE "WSRRLMGR" (LEASENAME VARCHAR(254) NOT NULL,
               LEASEOWNER VARCHAR(254) NOT NULL,
               LEASE_EXPIRE_TIME  BIGINT,
              DISABLED VARCHAR(5))IN "@DBNAME@SCHED";

ALTER TABLE "WSRRLMGR" ADD PRIMARY KEY ("LEASENAME");

CREATE TABLE "WSRRLMPR" (LEASENAME VARCHAR(254) NOT NULL,
              NAME VARCHAR(254) NOT NULL,
              VALUE VARCHAR(254) NOT NULL)IN "@DBNAME@SCHED";

CREATE INDEX "WSRRLMPR_IDX1" ON "WSRRLMPR" (LEASENAME,
               NAME);

GRANT SELECT,INSERT,UPDATE,DELETE ON WSRRTASK TO USER @DBUSER@;
GRANT SELECT,INSERT,UPDATE,DELETE ON WSRRTREG TO USER @DBUSER@;
GRANT SELECT,INSERT,UPDATE,DELETE ON WSRRLMGR TO USER @DBUSER@;
GRANT SELECT,INSERT,UPDATE,DELETE ON WSRRLMPR TO USER @DBUSER@;
