
CREATE SCHEMA @SIBSCHEMA@;

CREATE TABLE @SIBSCHEMA@.SIBOWNER (
  ME_UUID VARCHAR(16),
  INC_UUID VARCHAR(16),
  VERSION INTEGER,
  MIGRATION_VERSION INTEGER
);

CREATE TABLE @SIBSCHEMA@.SIBOWNERO (
  EMPTY_COLUMN INTEGER
);

CREATE TABLE @SIBSCHEMA@.SIBCLASSMAP (
  CLASSID INTEGER NOT NULL,
  URI VARCHAR(2048) NOT NULL,
  PRIMARY KEY(CLASSID)
);

CREATE TABLE @SIBSCHEMA@.SIBLISTING (
  ID INTEGER NOT NULL,
  SCHEMA_NAME VARCHAR(10),
  TABLE_NAME VARCHAR(10) NOT NULL,
  TABLE_TYPE CHAR(1) NOT NULL,
  PRIMARY KEY(ID)
);

CREATE TABLE @SIBSCHEMA@.SIB000 (
  ID BIGINT NOT NULL,
  STREAM_ID BIGINT NOT NULL,
  TYPE CHAR(2),
  EXPIRY_TIME BIGINT,
  STRATEGY INTEGER,
  REFERENCE BIGINT,
  CLASS_ID INTEGER NOT NULL,
  PRIORITY INTEGER,
  SEQUENCE BIGINT,
  PERMANENT_ID INTEGER,
  TEMPORARY_ID INTEGER,
  LOCK_ID BIGINT,
  DATA_SIZE INTEGER NOT NULL,
  DATA VARCHAR(3360) FOR BIT DATA,
  LONG_DATA BLOB(1G),
  XID VARCHAR(254),
  DELETED SMALLINT
);

CREATE UNIQUE INDEX @SIBSCHEMA@.SIB000PKIX ON @SIBSCHEMA@.SIB000 (ID) ALLOW
REVERSE SCANS;

CREATE INDEX @SIBSCHEMA@.SIB000STREAMIX ON
@SIBSCHEMA@.SIB000(STREAM_ID,SEQUENCE) ALLOW REVERSE SCANS;

ALTER TABLE @SIBSCHEMA@.SIB000 ADD CONSTRAINT SIB000PKIX PRIMARY KEY (ID);

ALTER TABLE @SIBSCHEMA@.SIB000 VOLATILE CARDINALITY;

CREATE TABLE @SIBSCHEMA@.SIB001 (
  ID BIGINT NOT NULL,
  STREAM_ID BIGINT NOT NULL,
  TYPE CHAR(2),
  EXPIRY_TIME BIGINT,
  STRATEGY INTEGER,
  REFERENCE BIGINT,
  CLASS_ID INTEGER NOT NULL,
  PRIORITY INTEGER,
  SEQUENCE BIGINT,
  PERMANENT_ID INTEGER,
  TEMPORARY_ID INTEGER,
  LOCK_ID BIGINT,
  DATA_SIZE INTEGER NOT NULL,
  DATA VARCHAR(3360) FOR BIT DATA,
  LONG_DATA BLOB(1G),
  XID VARCHAR(254),
  DELETED SMALLINT
);

CREATE UNIQUE INDEX @SIBSCHEMA@.SIB001PKIX ON @SIBSCHEMA@.SIB001 (ID) ALLOW
REVERSE SCANS;

CREATE INDEX @SIBSCHEMA@.SIB001STREAMIX ON
@SIBSCHEMA@.SIB001(STREAM_ID,SEQUENCE) ALLOW REVERSE SCANS;

ALTER TABLE @SIBSCHEMA@.SIB001 ADD CONSTRAINT SIB001PKIX PRIMARY KEY (ID);

ALTER TABLE @SIBSCHEMA@.SIB001 VOLATILE CARDINALITY;

CREATE TABLE @SIBSCHEMA@.SIB002 (
  ID BIGINT NOT NULL,
  STREAM_ID BIGINT NOT NULL,
  TYPE CHAR(2),
  EXPIRY_TIME BIGINT,
  STRATEGY INTEGER,
  REFERENCE BIGINT,
  CLASS_ID INTEGER NOT NULL,
  PRIORITY INTEGER,
  SEQUENCE BIGINT,
  PERMANENT_ID INTEGER,
  TEMPORARY_ID INTEGER,
  LOCK_ID BIGINT,
  DATA_SIZE INTEGER NOT NULL,
  DATA VARCHAR(3360) FOR BIT DATA,
  LONG_DATA BLOB(1G),
  XID VARCHAR(254),
  DELETED SMALLINT
);

CREATE UNIQUE INDEX @SIBSCHEMA@.SIB002PKIX ON @SIBSCHEMA@.SIB002 (ID) ALLOW
REVERSE SCANS;

CREATE INDEX @SIBSCHEMA@.SIB002STREAMIX ON
@SIBSCHEMA@.SIB002(STREAM_ID,SEQUENCE) ALLOW REVERSE SCANS;

ALTER TABLE @SIBSCHEMA@.SIB002 ADD CONSTRAINT SIB002PKIX PRIMARY KEY (ID);

ALTER TABLE @SIBSCHEMA@.SIB002 VOLATILE CARDINALITY;

CREATE TABLE @SIBSCHEMA@.SIBXACTS (
  XID VARCHAR(254) NOT NULL,
  STATE CHAR(1) NOT NULL,
  PRIMARY KEY(XID)
);

CREATE TABLE @SIBSCHEMA@.SIBKEYS (
  ID VARCHAR(50) NOT NULL,
  LAST_KEY BIGINT NOT NULL,
  PRIMARY KEY(ID)
);

GRANT SELECT,INSERT,UPDATE ON @SIBSCHEMA@.SIBOWNER TO USER @DBUSER@;

GRANT SELECT,INSERT,UPDATE ON @SIBSCHEMA@.SIBOWNERO TO USER @DBUSER@;

GRANT SELECT,INSERT ON @SIBSCHEMA@.SIBCLASSMAP TO USER @DBUSER@;

GRANT SELECT,INSERT ON @SIBSCHEMA@.SIBLISTING TO USER @DBUSER@;

GRANT SELECT,INSERT,DELETE,UPDATE ON @SIBSCHEMA@.SIB000 TO USER @DBUSER@;

GRANT SELECT,INSERT,DELETE,UPDATE ON @SIBSCHEMA@.SIB001 TO USER @DBUSER@;

GRANT SELECT,INSERT,DELETE,UPDATE ON @SIBSCHEMA@.SIB002 TO USER @DBUSER@;

GRANT SELECT,INSERT,UPDATE,DELETE ON @SIBSCHEMA@.SIBXACTS TO USER @DBUSER@;

GRANT SELECT,INSERT,UPDATE ON @SIBSCHEMA@.SIBKEYS TO USER @DBUSER@;

