@echo off

# Ensure that db2 manager is started.
@WSRR_DB2_HOME@/bin/db2start

rem -- Create the WSRR database --
if "@DBTYPE@" == "db2v8" (
	@WSRR_DB2_HOME@/bin/db2 -tf createdbts_v8.sql
) else (
	@WSRR_DB2_HOME@/bin/db2 -tf createdbts.sql
)

rem -- Create the SIBus database (optional) --
if "@SIBDBNAME@" != "@DBNAME@" (
	if "@DBTYPE@" == "db2v8" (
		@WSRR_DB2_HOME@/bin/db2 -tf createdbsib_v8.sql
	) else (
		@WSRR_DB2_HOME@/bin/db2 -tf createdbsib.sql
	)
)

rem -- Create the activity logging database (optional) --
if "@ACTDBNAME@" != "@DBNAME@" (
	if "@DBTYPE@" == "db2v8" (
		@WSRR_DB2_HOME@/bin/db2 -tf createdbact_v8_separatedb.sql
	) else (
		@WSRR_DB2_HOME@/bin/db2 -tf createdbact_separatedb.sql
	)
) else (
	if "@DBTYPE@" == "db2v8" (
		@WSRR_DB2_HOME@/bin/db2 -tf createdbact_v8.sql
	) else (
		@WSRR_DB2_HOME@/bin/db2 -tf createdbact.sql
	)
)

rem -- Create the database tables for the WSRR database --
@WSRR_DB2_HOME@/bin/db2 connect to @DBNAME@ user @DBUSER@ using @DBPASSWORD@
@WSRR_DB2_HOME@/bin/db2 set current schema @DBUSER@
@WSRR_DB2_HOME@/bin/db2 -tf createsched.sql
@WSRR_DB2_HOME@/bin/db2 -tf createts.sql
@WSRR_DB2_HOME@/bin/db2 terminate

rem -- Create the database tables for the SIBus database --
@WSRR_DB2_HOME@/bin/db2 connect to @SIBDBNAME@ user @SIBDBUSER@ using @SIBDBPASSWORD@
@WSRR_DB2_HOME@/bin/db2 set current schema @SIBSCHEMA@
@WSRR_DB2_HOME@/bin/db2 -tf createsib.sql
@WSRR_DB2_HOME@/bin/db2 terminate

rem -- Create the database tables for the activity logging database --
@WSRR_DB2_HOME@/bin/db2 connect to @ACTDBNAME@ user @ACTDBUSER@ using @ACTDBPASSWORD@
@WSRR_DB2_HOME@/bin/db2 set current schema @ACTDBUSER@
@WSRR_DB2_HOME@/bin/db2 -tf createact.sql
@WSRR_DB2_HOME@/bin/db2 terminate

@WSRR_DB2_HOME@/bin/db2stop
@WSRR_DB2_HOME@/bin/db2start

if ERRORLEVEL 4 goto dberror
echo DB INITIALIZATION WAS SUCCESSFUL
goto end

:dberror
echo DB INITIALIZATION FAILED

:end
