#!/bin/sh

. ~/sqllib/db2profile

#db2set DB2COMM=tcpip
#db2 update dbm cfg using SVCENAME db2c_@WSRR_DB2_INSTANCE_NAME@

# Ensure that the db2c_@WSRR_DB2_INSTANCE_NAME@ service is defined in /etc/services.
#db2stop
#db2start

# Ensure that db2 manager is started.
db2start

# -- Create the WSRR database --
if [ "@DBTYPE@" == "db2v8" ]; then
	db2 -tf createdbts_v8.sql
else
	db2 -tf createdbts.sql
fi

# -- Create the SIBus database (optional) --
if [ "@SIBDBNAME@" != "@DBNAME@" ]; then
	if [ "@DBTYPE@" == "db2v8" ]; then
		db2 -tf createdbsib_v8.sql
	else
		db2 -tf createdbsib.sql
	fi
fi

# -- Create the activity logging database (optional) --
if [ "@ACTDBNAME@" != "@DBNAME@" ]; then
	if [ "@DBTYPE@" == "db2v8" ]; then
		db2 -tf createdbact_v8_separatedb.sql
	else
		db2 -tf createdbact_separatedb.sql
	fi
else
	if [ "@DBTYPE@" == "db2v8" ]; then
		db2 -tf createdbact_v8.sql
	else
		db2 -tf createdbact.sql
	fi
fi

# -- Create the database tables for the WSRR database --
db2 connect to @DBNAME@ user @DBUSER@ using @DBPASSWORD@
db2 set current schema @DBUSER@
db2 -tf createsched.sql
db2 -tf createts.sql
db2 terminate

# -- Create the database tables for the SIBus database --
db2 connect to @SIBDBNAME@ user @SIBDBUSER@ using @SIBDBPASSWORD@
db2 set current schema @SIBSCHEMA@
db2 -tf createsib.sql
db2 terminate

# -- Create the database tables for the activity logging database --
db2 connect to @ACTDBNAME@ user @ACTDBUSER@ using @ACTDBPASSWORD@
db2 set current schema @ACTDBUSER@
db2 -tf createact.sql
db2 terminate

#db2stop
#db2start
